<?php
/*
Plugin Name: Mailing-List
Version: 4.0beta
Plugin URI: http://gerard.ly.free.fr/
Description: Send mails to a mailing-list and manage the list. Send newsletter every time a new post is added or edited.
Author: Gerard LY
Author URI: http://gerard.ly.free.fr/
*/
/*
  Copyright (c) 2005, Gerard LY

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//----------------------------------------<   Main Program   >------------------------------------------//
add_option('ml_sending_format', '0');
add_option('ml_sending_encoding', '0');
add_option('ml_newsletter_users', '0');
add_option('ml_newsletter_queuing', '');
add_option('ml_newsletter_amount', '1');
add_option('ml_newsletter_title', '[BLOGNAME] has been updated!');
add_option('ml_newsletter_text', "A new entry titled [TITLE] has been posted to [BLOGNAME]\n".
                                 "[EXCERPT]\n".
                                 "You may view the latest post at [PERMALINK]\n");
add_option('ml_newsletter_footer', "If you want to enable or disable the newsletter but still want to receive admin notifications then use this link: [NEWSLETTER]\n".
                                   "If you no longer wish to receive admin's or news posts notifications then please unsubscribe: [UNSUBSCRIBE]");
add_option('ml_send_newsletter', '1');
add_option('ml_insert_footer', '0');
add_action('admin_menu', 'ml_menu');
add_action('admin_head', 'ml_css');
add_action('publish_post', 'ml_newsletter', 5);
add_filter('admin_footer', 'ml_post_footer', 5);
load_plugin_textdomain('mailing-list');

require_once(ABSPATH . '/wp-admin/upgrade-functions.php');
$wpdb->hide_errors();
$wpdb->mailinglist = $table_prefix . 'mailinglist';
$installed = $wpdb->get_results("SELECT mluser_category FROM $wpdb->mailinglist");

if (mysql_errno() == 1146) {
$query = "CREATE TABLE $wpdb->mailinglist (
  ID bigint(20) unsigned NOT NULL auto_increment,
  mluser_firstname varchar(50) NOT NULL default '',
  mluser_lastname varchar(50) NOT NULL default '',
  mluser_address varchar(200) NOT NULL default '',
  mluser_email varchar(100) NOT NULL default '',
  mluser_phone varchar(50) NOT NULL default '',
  mluser_newsletter tinyint(1) unsigned NOT NULL default '1',
  mluser_category varchar(50) NOT NULL default '',
  PRIMARY KEY  (ID),
  UNIQUE KEY mluser_email (mluser_email)
)";
$wpdb->query($query);
}
elseif (mysql_errno() == 1054) {
$query = "ALTER TABLE $wpdb->mailinglist ADD COLUMN mluser_category varchar(50) NOT NULL default ''";
$wpdb->query($query);
}
//------------------------------------------- End of Main Program --------------------------------------//


//----------------------------------------<   Action Program   >----------------------------------------//
require_once(ABSPATH . '/wp-includes/pluggable-functions.php');
get_currentuserinfo();

$wpvarstoreset = array('action');
for ($i=0; $i<count($wpvarstoreset); $i += 1) {
	$wpvar = $wpvarstoreset[$i];
	if (!isset($$wpvar)) {
		if (empty($_POST["$wpvar"])) {
			if (empty($_GET["$wpvar"])) {
				$$wpvar = '';
			} else {
				$$wpvar = $_GET["$wpvar"];
			}
		} else {
			$$wpvar = $_POST["$wpvar"];
		}
	}
}

switch ($action) {
case 'addmluser':
	if ($user_level < 6) die(__("This address is used only for admin purposes.", "mailing-list"));
	ml_check_form();
	ml_check_email($mluser_email, 0);

	$result = $wpdb->query("INSERT INTO $wpdb->mailinglist
		(mluser_firstname, mluser_lastname, mluser_address, mluser_email, mluser_phone, mluser_newsletter, mluser_category)
	VALUES
		('$mluser_firstname', '$mluser_lastname', '$mluser_address', '$mluser_email', '$mluser_phone', '$mluser_newsletter', '$mluser_category')");

	if ($result == false) die (__("<strong>ERROR</strong>: ").__("Couldn't register you!", "mailing-list"));

	header('Location: '.$_SERVER['SCRIPT_NAME'].'?page=mailing-list.php&category='.$_GET[category].'&result=added');
break;

case 'editmluser':
	if ($user_level < 6) die(__("This address is used only for admin purposes.", "mailing-list"));
	ml_check_form();
	ml_check_email($mluser_email, $mluser_id);

	$result = $wpdb->query("UPDATE $wpdb->mailinglist SET mluser_firstname='$mluser_firstname', mluser_lastname='$mluser_lastname', mluser_address='$mluser_address', mluser_email='$mluser_email', mluser_phone='$mluser_phone', mluser_newsletter='$mluser_newsletter', mluser_category='$mluser_category' WHERE ID=$mluser_id");

	if ($result == false) die (__("<strong>ERROR</strong>: ").__("Couldn't register you!", "mailing-list"));

	header('Location: '.$_SERVER['SCRIPT_NAME'].'?page=mailing-list.php&category='.$_GET[category].'&result=edited');
break;

case 'deletemluser':
	$id = (int) $_GET['id'];

	if (!$id) {
		header('Location: '.$_SERVER['SCRIPT_NAME'].'?page=mailing-list.php');
	}

	if ($user_level < 6) die(__("This address is used only for admin purposes.", "mailing-list"));

	$wpdb->query("DELETE FROM $wpdb->mailinglist WHERE ID=$id");
	header('Location: '.$_SERVER['SCRIPT_NAME'].'?page=mailing-list.php&category='.$_GET[category].'&result=deleted');
break;

case 'updateml':
	if (isset($_POST['format'])) { update_option('ml_sending_format', $_POST['format']); }
	if (isset($_POST['encoding'])) { update_option('ml_sending_encoding', $_POST['encoding']); }
	if (isset($_POST['newsletter_users'])) { update_option('ml_newsletter_users', $_POST['newsletter_users']); }
	if (isset($_POST['newsletter_amount'])) { update_option('ml_newsletter_amount', $_POST['newsletter_amount']); }
	if (isset($_POST['newsletter_title'])) { update_option('ml_newsletter_title', stripslashes($_POST['newsletter_title'])); }
	if (isset($_POST['newsletter_text'])) { update_option('ml_newsletter_text', stripslashes($_POST['newsletter_text'])); }
	if (isset($_POST['newsletter_footer'])) { update_option('ml_newsletter_footer', stripslashes($_POST['newsletter_footer'])); }
	if (isset($_POST['send_newsletter'])) { update_option('ml_send_newsletter', $_POST['send_newsletter']); }
	header('Location: '.$_SERVER['HTTP_REFERER'].'&result=updated');
break;
}
//------------------------------------------- End of Action Program ------------------------------------//


//----------------------------------------<   Footer for Post Page   >----------------------------------//
function ml_post_footer($ignored) {
if(!preg_match('|post.php|i', $_SERVER['SCRIPT_NAME']) || preg_match('|edit-pages.php|i', $_SERVER['HTTP_REFERER']) || ($_GET['action'] == "editcomment") || ($_GET['page'] == "mailing-list.php")) {
return;
}
else {
$notify = 'ml_send_notification';
$notify_label = __("Send notification for this post to the newsletter ", "mailing-list");

if (get_option('ml_send_newsletter')) {
	$notify = 'ml_add_notification';
	$notify_label = __("Add notification for this post in the newsletter", "mailing-list");
}

?>
<fieldset id="ml_post_footer">
  <legend><a href="options-general.php?page=mailing-list.php"><?php _e("Mailing-List", "mailing-list") ?></a></legend>
  <p>
    <label><input id="ml_notify" name="<?php echo $notify ?>" type="checkbox" <?php if (($notify == 'ml_add_notification') && ($_GET['action'] != 'edit')) echo 'checked="checked"' ?>/> <?php echo $notify_label ?><label>
  </p>
</fieldset>

<script language="JavaScript" type="text/javascript">
if(document.getElementById("postdivrich")) {
  document.getElementById("postdivrich").appendChild(document.getElementById("ml_post_footer"));
}
else {
  document.getElementById("postdiv").appendChild(document.getElementById("ml_post_footer"));
}
</script>
<?php
  }
}
//------------------------------------------- End of Footer for Post Page ------------------------------//


//----------------------------------------<   Write Mail Page   >---------------------------------------//
function ml_post_page() {
global $wpdb, $users, $user_level, $user_email, $action, $user_ID;

update_option('ml_insert_footer', $_POST['insert_footer']);

if (isset($_POST['action']) && $_POST['action'] == send) {
ml_send_mail($user_email, $_POST['mailto'], $_POST['mailcc'], $_POST['mailbcc'], $_POST['mailtitle'], $_POST['content'], $_POST['format']);
echo '<div class="updated"><p>'.__("E-mail has been sent", "mailing-list").'</p></div>';
}

$mailinglist = $wpdb->get_results("SELECT mluser_firstname, mluser_lastname, mluser_email, mluser_category FROM $wpdb->mailinglist ORDER BY ID");
$users = $wpdb->get_results("SELECT ID, user_nicename, user_email FROM $wpdb->users ORDER BY ID");
?>

<div class="wrap">
<h2><?php _e("Write Mail", "mailing-list") ?></h2>

<form name="post" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>?page=mailing-list.php" method="post" id="post" enctype="multipart/form-data">
<input type="hidden" name="user_ID" value="<?php echo $user_ID ?>" />
<input type="hidden" name="action" value="send" />
<input type="hidden" name="post_status" value="static" />

<script type="text/javascript">
<!--
var mlusers = new Array();
var users = new Array();
<?php
$categorylist = array();

if ($mailinglist) {
	foreach ($mailinglist as $key =>$ml_user) {
		$catusers[$ml_user->mluser_category][$key] = $ml_user->mluser_email;
		$categorylist[$ml_user->mluser_category] = $ml_user->mluser_category;
		echo "mlusers[$key] = '$ml_user->mluser_email';\n";
	}
}

foreach ($users as $key =>$user) {
	echo "users[$key] = '$user->user_email';\n";
}

$i = '0';
$emails_array = '';
foreach ($categorylist as $categoryitem) {
	echo "\nvar categories$i =  new Array();\n";
	$j = '0';
	foreach ($catusers[$categoryitem] as $value) {
		echo "categories".$i."[".$j++."] = '$value';\n";
	}
	$emails_array .= ", categories$i";
	$i++;
}
?>

var emails = new Array(mlusers, users<?php echo $emails_array ?>);

function focusit() {
    // focus on first input field
    document.post.title.focus();
}

function set(value) {
current = value;
document.post.to.style.borderWidth = '1px';
document.post.cc.style.borderWidth = '1px';
document.post.bcc.style.borderWidth = '1px';
document.post.elements[current].style.borderWidth = '2px';
}

function addtxt() {
  addvalue = document.post.email.value;
  if ((addvalue.indexOf('@') == -1) && emails[addvalue].length > 0) {
    addlist = emails[addvalue][0];
    for(i = 1; i < emails[addvalue].length; i++) {
      addlist = addlist+' , '+emails[addvalue][i];
    }
  addvalue = addlist;
  }
  if (document.post.elements[current].value.indexOf(addvalue) == -1 && addvalue != 0) {
    if (document.post.elements[current].value == '') {
      document.post.elements[current].value = unescape(addvalue)
    } else {
      document.post.elements[current].value = document.post.elements[current].value+' , '+unescape(addvalue)
    }
  }
  document.post.elements[current].focus();
}

function showtags() {
  if (document.post.format.value == 1) {
    document.getElementById('quicktags').style.display = 'block';
  } else {
    document.getElementById('quicktags').style.display = 'none';
  }
}

window.onload = focusit;
window.onload = showtags;
var current = 'to';
//-->
</script>

    <fieldset id="emaildiv">
      <legend><?php _e("Mailing-List", "mailing-list") ?></legend>
      <div>
        <input onclick="addtxt()" id="addemail" value="+" type="button" />
        <select name="email" class="select_email">
          <optgroup label="<?php _e("Mailing-List", "mailing-list") ?>">
            <option value="0"><?php ($mailinglist) ? _e("Send to All Mailing-List Users", "mailing-list") : _e("Empty", "mailing-list") ?></option>
<?php
if ($mailinglist) {
	foreach ($mailinglist as $ml_user) {
		echo "            <option value='$ml_user->mluser_email'>$ml_user->mluser_firstname $ml_user->mluser_lastname ($ml_user->mluser_email)</option>\n";
	}
}
?>
          </optgroup>
          <optgroup label="<?php _e("Blog Users", "mailing-list") ?>">
            <option value="1"><?php _e("Send to All Blog Users", "mailing-list") ?></option>
<?php
foreach ($users as $user) {
	echo "          <option value='$user->user_email'>$user->user_nicename ($user->user_email)</option>\n";
}
?>
          </optgroup>
          <optgroup label="<? _e("Categories", "mailing-list") ?>">
<?php
$i = '2';
foreach ($categorylist as $categorykey => $categoryitem) {
	if ($categoryitem == '') {
		$categorykey = 'Uncategorized';
 		$categoryitem = __("[Uncategorized]", "mailing-list");
  }
	echo "            <option value='".$i++."'>".$categoryitem."</option>\n";
}
?>
          </optgroup>
        </select>
      </div>
    </fieldset>
    <fieldset id="todiv">
      <legend><?php _e("To", "mailing-list") ?></legend>
      <div><input name="mailto" type="text" size="75" id="to" value="<?php echo $_POST['mailto'] ?>" onfocus="set('to')" /></div>
    </fieldset>
    <fieldset id="ccdiv">
      <legend><?php _e("CC", "mailing-list") ?></legend>
      <div><input name="mailcc" type="text" size="75" id="cc" value="<?php echo $_POST['mailcc'] ?>" onfocus="set('cc')" /></div>
    </fieldset>
    <fieldset id="attachdiv">
      <legend><?php _e("Attach File", "mailing-list") ?></legend>
       <div><input type="file" size="30" name="file" id="attach"/></div>
    </fieldset>
    <fieldset id="bccdiv">
      <legend><?php _e("BCC", "mailing-list") ?></legend>
      <div><input name="mailbcc" type="text" size="75" id="bcc" value="<?php echo $_POST['mailbcc'] ?>" onfocus="set('bcc')" /></div>
    </fieldset>
    <fieldset id="formatdiv">
      <legend><?php _e("Sending Options", "mailing-list") ?></legend>
      <div><select name="format" onchange="showtags()">
        <option value="0"><?php _e("Text Format", "mailing-list"); ?></option>
        <option value="1"<?php if (get_option('ml_sending_format')) echo ' selected="selected"'; ?>><?php _e("HTML Format", "mailing-list"); ?></option>
        </select>
        <label for="sending_options" class="sending_options">
          <input name="insert_footer" id="insert_footer" type="checkbox" <?php if (get_option('ml_insert_footer')) echo ' checked="checked"'; ?>/>
          <?php _e("Insert Newsletter Footer", "mailing-list") ?>

        </label>
      </div>
    </fieldset>
    <fieldset id="titlediv">
      <legend><?php _e("Title", "mailing-list") ?></legend>
       <div><input type="text" name="mailtitle" size="75" tabindex="1" value="<?php echo stripslashes($_POST['mailtitle']) ?>" id="title" /></div>
    </fieldset>
<fieldset id="postdiv">
    <legend><?php _e("Message Content", "mailing-list") ?></legend>
<?php the_quicktags(); ?>
<?php
 $rows = get_settings('default_post_edit_rows');
 if (($rows < 3) || ($rows > 100)) {
     $rows = 10;
 }
?>
<div><textarea rows="<?php echo $rows; ?>" cols="40" name="content" tabindex="4" id="content"><?php echo stripslashes($_POST['content']) ?></textarea></div>
</fieldset>

<script type="text/javascript">
<!--
edCanvas = document.getElementById('content');
//-->
</script>

<p class="submit">
  <input name="sendmail" type="submit" id="sendmail" tabindex="6" value="<?php _e("Send Mail", "mailing-list") ?> &raquo;" />
  <input name="referredby" type="hidden" id="referredby" value="<?php echo $sendto; ?>" />
</p>

</form>
</div>
<?php
}
//------------------------------------------- End of Write Mail Page -----------------------------------//


//----------------------------------------<   Mailing-list Page   >-------------------------------------//
function ml_edit_page() {
global $wpdb, $user_level, $action;
if (isset($_GET['result']) && $_GET['result'] == ('added' || 'deleted' || 'edited')) {
	echo '<div class="updated"><p>'.sprintf(__("User %s", "mailing-list"), __($_GET['result'], "mailing-list")).'</p></div>';
}

$newsletter[0]='No';
$newsletter[1]='Yes';

$category = __("All Categories", "mailing-list");
$mailinglist = $wpdb->get_results("SELECT * FROM $wpdb->mailinglist ORDER BY ID");

if ($mailinglist) {
	foreach ($mailinglist as $key => $ml_user) {
		$categorylist[$ml_user->mluser_category]=$ml_user->mluser_category;
	}
}

if (isset($_GET['category']) && $_GET['category'] != __("All Categories", "mailing-list")) {
  ($_GET['category'] == '') ? ($category = __("[Uncategorized]", "mailing-list")) : ($category = $_GET['category']);
  $mailinglist = $wpdb->get_results("SELECT * FROM $wpdb->mailinglist WHERE mluser_category='".$_GET['category']."' ORDER BY ID");
}

?>
<div class="wrap">
	<h2><?php _e("Mailing-List Users", "mailing-list") ?></h2>
	<h3><?php printf(__("Category: %s"), $category) ?><?php if (!$mailinglist) { echo ' ('.__("Empty", "mailing-list").')'; } ?></h3>
	<form action="<?php echo $_SERVER['SCRIPT_NAME']; ?>" method="get" name="changecategory" id="changecategory">
		<input name="page" type="hidden" value="mailing-list.php">
		<select name="category" id="select_category" onchange="document.changecategory.submit()">
			<option value=""><?php _e("Show a category", "mailing-list") ?></option>
			<option value="<?php _e("All Categories", "mailing-list") ?>"><?php _e("All Categories", "mailing-list") ?></option>
<?php
    foreach ($categorylist as $key => $value) {
      if ($value == '') { $value = __("[Uncategorized]", "mailing-list"); }
    	echo '			<option value="'.$key.'">'.$value.'</option>'."\n";
    }
?>
		</select>
	</form>

<?php 
if ($mailinglist) {
?>
	<table cellpadding="3" cellspacing="3" width="100%">
	<tr>
		<th><?php _e("ID", "mailing-list") ?></th>
		<th><?php _e("Name", "mailing-list") ?></th>
		<th><?php _e("Address", "mailing-list") ?></th>
		<th><?php _e("E-mail", "mailing-list") ?></th>
		<th><?php _e("Phone", "mailing-list") ?></th>
		<th><?php _e("Newsletter", "mailing-list") ?></th>
		<th><?php _e("Category", "mailing-list") ?></th>
		<th></th>
		<th></th>
	</tr>
<?php
$style = '';
foreach ($mailinglist as $ml_user) {
	$email = $ml_user->mluser_email;
	$style = ('class="alternate"' == $style) ? '' : 'class="alternate"';
echo "\n<tr $style>
<td align='center'>$ml_user->ID</td>
<td align='center'>$ml_user->mluser_firstname $ml_user->mluser_lastname</td>
<td align='center'>$ml_user->mluser_address</td>
<td align='center'><a href='mailto:$email' title='".sprintf(__("e-mail: %s", "mailing-list"), $email)."'>$email</a></td>
<td align='center'>$ml_user->mluser_phone</td>
<td align='center'>".__($newsletter[$ml_user->mluser_newsletter])."</td>
<td align='center'>$ml_user->mluser_category</td>
<td align='center'>";
	if ($user_level >= 6)
		echo "<a href='".$_SERVER['SCRIPT_NAME']."?page=mailing-list.php&amp;action=edit&amp;category=$category&amp;id=$ml_user->ID' class='edit'>".__("Edit", "mailing-list")."</a>";
	echo '</td><td>';
	if ($user_level >= 6)
		echo "<a href='".$_SERVER['SCRIPT_NAME']."?page=mailing-list.php&amp;action=deletemluser&amp;category=$category&amp;id=$ml_user->ID' class='delete' onclick='return confirm(\"".__('You are about to delete this user \n  OK to delete, Cancel to stop.')."\")'>".__("Delete", "mailing-list").'</a>';
	echo '</td></tr>';

	if ($ml_user->ID == $_GET['id']) {
		$mluser_id        = $ml_user->ID;
		$mluser_firstname = $ml_user->mluser_firstname;
		$mluser_lastname  = $ml_user->mluser_lastname;
		$mluser_address   = $ml_user->mluser_address;
		$mluser_email     = $ml_user->mluser_email;
		$mluser_phone     = $ml_user->mluser_phone;
		$mluser_newsletter= $ml_user->mluser_newsletter;
		$mluser_category  = $ml_user->mluser_category;
	}
}

?>

	</table>
<?php
}
?>
</div>

<div class="wrap">
<h2><?php ($action == 'edit')?_e("Edit User", "mailing-list"):_e("Add New User", "mailing-list") ?></h2>
<form action="<?php echo $_SERVER['SCRIPT_NAME']; ?>" method="post" name="adduser" id="adduser">
  <input name="action" type="hidden" id="action" value="<?php ($action == 'edit') ? print('editmluser').'" />'."\n  ".'<input name="id" type="hidden" id="id" value="'.$mluser_id  : print('addmluser') ?>" />
  <table class="editform" width="100%" cellspacing="2" cellpadding="5">
    <tr>
      <th scope="row" width="33%"><?php _e("First Name", "mailing-list") ?></th>
      <td><input name="firstname" type="text" id="firstname"<?php if (isset($mluser_firstname)) echo ' value="'.$mluser_firstname.'"'; ?> /></td>
    </tr>
    <tr>
      <th scope="row"><?php _e("Last Name", "mailing-list") ?></th>
      <td><input name="lastname" type="text" id="lastname"<?php if (isset($mluser_lastname)) echo ' value="'.$mluser_lastname.'"'; ?> /></td>
    </tr>
    <tr>
      <th scope="row"><?php _e("Address", "mailing-list") ?></th>
      <td><input name="address" type="text" id="address"<?php if (isset($mluser_address)) echo ' value="'.$mluser_address.'"'; ?> /></td>
    </tr>
    <tr>
      <th scope="row"><?php _e("E-mail", "mailing-list") ?></th>
      <td><input name="email" type="text" id="email"<?php if (isset($mluser_email)) echo ' value="'.$mluser_email.'"'; ?> /></td>
    </tr>
    <tr>
      <th scope="row"><?php _e("Phone", "mailing-list") ?></th>
      <td><input name="phone" type="text" id="phone"<?php if (isset($mluser_phone)) echo ' value="'.$mluser_phone.'"'; ?> /></td>
    </tr>
    <tr>
      <th scope="row"><?php _e("Newsletter", "mailing-list") ?></th>
      <td>
        <label><input name="newsletter" value="1" type="radio"<?php if ($mluser_newsletter || !$action == 'edit' ) echo ' checked="checked"'; ?> /><?php _e("Yes", "mailing-list") ?><br /></label>
        <label><input name="newsletter" value="0" type="radio"<?php if (!$mluser_newsletter && $action == 'edit' ) echo ' checked="checked"'; ?> /><?php _e("No", "mailing-list") ?></label>
      </td>
    </tr>
    <tr>
      <th scope="row"><?php _e("Category", "mailing-list") ?></th>
      <td><input name="category" type="text" id="category"<?php if (isset($mluser_category)) echo ' value="'.$mluser_category.'"'; ?> /></td>
    </tr>
  </table>
  <p class="submit">
    <input name="submit_user" type="submit" id="submit_user" value="<?php ($action == 'edit') ? _e("Edit User", "mailing-list") : _e("Add User", "mailing-list") ?>" &raquo;" />
  </p>
  </form>
</div>
	<?php
}
//------------------------------------------- End of Mailing-list Page ---------------------------------//


//-----------------------------------------<   Mailing-list Options Page   >----------------------------//
function ml_options_page() {
if (isset($_GET['result']) && $_GET['result'] == 'updated') {
echo '<div class="updated"><p>'.__("Updated", "mailing-list").'</p></div>';
}
?>
<div class="wrap">
<h2><?php _e("Mailing-List Options", "mailing-list") ?></h2>
<form name="mloptions" method="post" action="<?php echo $_SERVER['SCRIPT_NAME'].'?page=mailing-list.php' ?>">
  <input type="hidden" name="action" value="updateml" />
  <fieldset class="options"><legend>Email Options</legend>
  <table width="100%" cellspacing="2" cellpadding="5" class="editform">
    <tr valign="top">
      <th width="33%" scope="row"><?php _e("Sending Format:", "mailing-list") ?></th>
      <td width="8%">
        <label><input name="format" value="1" type="radio"<?php if (get_option('ml_sending_format')) echo ' checked="checked"'; ?> /><?php _e("HTML", "mailing-list") ?></label>
      </td>
      <td>
        <label><input name="format" value="0" type="radio"<?php if (!get_option('ml_sending_format')) echo ' checked="checked"'; ?> /><?php _e("Text", "mailing-list") ?></label>
      </td>
    </tr>
    <tr valign="top">
      <th scope="row"><?php _e("Sending Encoding:", "mailing-list") ?></th>
      <td>
        <label><input name="encoding" value="1" type="radio" <?php if (get_option('ml_sending_encoding')) echo ' checked="checked"'; ?> /><?php _e("Base 64", "mailing-list") ?></label>
      </td>
      <td>
        <label><input name="encoding" value="0" type="radio" <?php if (!get_option('ml_sending_encoding')) echo ' checked="checked"'; ?> /><?php _e("Normal", "mailing-list") ?></label>
      </td>
    </tr>
    <tr valign="top">
      <th scope="row"><?php _e("Send Newsletter:", "mailing-list") ?></th>
      <td>
        <label><input name="send_newsletter" value="1" type="radio" <?php if (get_option('ml_send_newsletter')) echo ' checked="checked"'; ?> /><?php _e("Yes", "mailing-list") ?></label>
      </td>
      <td>
        <label><input name="send_newsletter" value="0" type="radio" <?php if (!get_option('ml_send_newsletter')) echo ' checked="checked"'; ?> /><?php _e("No", "mailing-list") ?></label>
      </td>
    </tr>
    <tr valign="top">
      <th scope="row"><?php _e("Send to Blog Users:", "mailing-list") ?></th>
      <td>
        <label><input name="newsletter_users" value="1" type="radio" <?php if (get_option('ml_newsletter_users')) echo ' checked="checked"'; ?> /><?php _e("Yes", "mailing-list") ?></label>
      </td>
      <td>
        <label><input name="newsletter_users" value="0" type="radio" <?php if (!get_option('ml_newsletter_users')) echo ' checked="checked"'; ?> /><?php _e("No", "mailing-list") ?></label>
      </td>
    </tr>
    <tr valign="top">
      <th scope="row"><?php _e("Posts in the newsletter:", "mailing-list") ?></th>
      <td colspan="2">
        <label><input name="newsletter_amount" value="1" type="radio" <?php if (get_option('ml_newsletter_amount') == '1') echo ' checked="checked"'; ?> />1 </label>&nbsp;&nbsp;
        <label><input name="newsletter_amount" value="2" type="radio" <?php if (get_option('ml_newsletter_amount') == '2') echo ' checked="checked"'; ?> />2 </label>&nbsp;&nbsp;
        <label><input name="newsletter_amount" value="3" type="radio" <?php if (get_option('ml_newsletter_amount') == '3') echo ' checked="checked"'; ?> />3 </label>&nbsp;&nbsp;
        <label><input name="newsletter_amount" value="4" type="radio" <?php if (get_option('ml_newsletter_amount') == '4') echo ' checked="checked"'; ?> />4 </label>&nbsp;&nbsp;
        <label><input name="newsletter_amount" value="5" type="radio" <?php if (get_option('ml_newsletter_amount') == '5') echo ' checked="checked"'; ?> />5 </label>&nbsp;&nbsp;
        <label><input name="newsletter_amount" value="6" type="radio" <?php if (get_option('ml_newsletter_amount') == '6') echo ' checked="checked"'; ?> />6 </label>&nbsp;&nbsp;
        <label><input name="newsletter_amount" value="7" type="radio" <?php if (get_option('ml_newsletter_amount') == '7') echo ' checked="checked"'; ?> />7 </label>&nbsp;&nbsp;
        <label><input name="newsletter_amount" value="8" type="radio" <?php if (get_option('ml_newsletter_amount') == '8') echo ' checked="checked"'; ?> />8 </label>&nbsp;&nbsp;
        <label><input name="newsletter_amount" value="9" type="radio" <?php if (get_option('ml_newsletter_amount') == '9') echo ' checked="checked"'; ?> />9 </label>&nbsp;&nbsp;
        <label><input name="newsletter_amount" value="10" type="radio" <?php if (get_option('ml_newsletter_amount') == '10') echo ' checked="checked"'; ?> />10 </label>&nbsp;&nbsp;
      </td>
    </tr>
  </table>
  </fieldset>
  <fieldset class="options"><legend><?php _e("Newsletter Template", "mailing-list") ?></legend>
    <fieldset id="titlediv">
      <legend><?php _e("Title", "mailing-list") ?></legend>
       <div><input type="text" name="newsletter_title" size="70" tabindex="1" value="<?php echo get_option('ml_newsletter_title') ?>" id="title" /></div>
    </fieldset>
    <fieldset id="substitionsdiv"><legend>Message substitions:</legend>
    <ul class="substitions">
      <li><strong>[BLOGNAME]</strong> <?php bloginfo('name') ?></li>
      <li><strong>[BLOGLINK]</strong> <?php bloginfo('url') ?></li>
      <li><strong>[TITLE]</strong> <?php _e("the post's title", "mailing-list") ?></li>
      <li><strong>[EXCERPT]</strong> <?php _e("the excerpt of the post", "mailing-list") ?></li>
      <li><strong>[POST]</strong> <?php _e("the entire post", "mailing-list") ?></li>
      <li><strong>[PERMALINK]</strong> <?php _e("the post's permalink", "mailing-list") ?></li>
      <li><strong>[NEWSLETTER]</strong> <?php _e("enable/disable newsletter link", "mailing-list") ?></li>
      <li><strong>[UNSUBSCRIBE]</strong> <?php _e("unsubscribe link", "mailing-list") ?></li>
      <li><strong>[MYNAME]</strong> <?php _e("the post author's name", "mailing-list") ?></li>
      <li><strong>[EMAIL]</strong> <?php _e("the post author's email", "mailing-list") ?></li>
    </ul>
    </fieldset>
    <fieldset id="newsletterdiv">
      <legend><?php _e("Message Content", "mailing-list") ?></legend>
      <div><textarea rows="6" cols="65" name="newsletter_text" id="content"><?php echo get_option('ml_newsletter_text') ?></textarea></div>
    </fieldset>
    <fieldset id="footerdiv">
      <legend><?php _e("Footer", "mailing-list") ?></legend>
      <div><textarea rows="4" cols="65" name="newsletter_footer" id="content"><?php echo get_option('ml_newsletter_footer') ?></textarea></div>
    </fieldset>
  </fieldset>
  <p class="submit">
    <input type="submit" name="Submit" value="<?php _e("Update Options") ?> &raquo;" />
  </p>
</form>
</div>
<?php
}
//--------------------------------------------End of Mailing-list Options Page -------------------------//


//-----------------------------------------<   Send Newsletter   >--------------------------------------//
function ml_newsletter($post_ID) {
if ((get_option('ml_send_newsletter') && !$_POST['ml_add_notification']) || (!get_option('ml_send_newsletter') && !$_POST['ml_send_notification'])) { return; }

global $wpdb, $user_email, $action;
$format = get_option('ml_sending_format');
$bcc = '';
$mailinglist = $wpdb->get_results("SELECT * FROM $wpdb->mailinglist WHERE mluser_newsletter=1 ORDER BY ID");
foreach ($mailinglist as $ml_user) {
	$bcc .= $ml_user->mluser_email.' , ';
}
if (get_option('ml_newsletter_users')) {
	$blog_users = $wpdb->get_results("SELECT * FROM $wpdb->users ORDER BY ID");
	foreach ($blog_users as $blog_user) {
		if (!ereg($blog_user, $bcc)) {
			$bcc .= $blog_user->user_email.' , ';
		}
	}
}
$bcc = substr($bcc, 0 ,-3);

$msg ='';

if ($_POST['ml_send_notification']) {
	$amount = 1;
	$ml_newsletter_queuing ='<post>'.$post_ID.'</post>';
}
else {
	$amount = get_option('ml_newsletter_amount');
	$ml_newsletter_queuing = get_option('ml_newsletter_queuing');
	if (!ereg('<post>'.$post_ID.'</post>', $ml_newsletter_queuing)) {
		$ml_newsletter_queuing .='<post>'.$post_ID.'</post>';
	}
}

$content = get_option('ml_newsletter_text');

preg_match_all("/<post>([0-9]+)<\/post>/", $ml_newsletter_queuing, $newsletter_posts);

if (count($newsletter_posts[1]) >= $amount) {
	foreach ($newsletter_posts[1] as $post_ID) {
		$postdata = get_postdata($post_ID);
		$title = get_option('ml_newsletter_title');
		$title = ml_substitutions($post_ID, $postdata, $title, $format);
		$msg .= ml_substitutions($post_ID, $postdata, $content."\n\n\n", $format);
	}
}
else {
	update_option('ml_newsletter_queuing', $ml_newsletter_queuing);
	return;
}

$footer = "\n";
$footer .= get_option('ml_newsletter_footer');
$msg .= ml_substitutions($post_ID, $postdata, $footer, $format);

ml_send_mail($user_email, $user_email, '', $bcc, $title, $msg, $format);
update_option('ml_newsletter_queuing', '');

return;
}
//-------------------------------------------- End of Send Newsletter ----------------------------------//


//------------------------------<   function ml_substitutions   >----------------------//
function ml_substitutions($post_ID, $postdata, $item, $format) {
global $user_email, $current_user;

if ($format) {
	$item = ereg_replace('(\[BLOGLINK\]|\[PERMALINK\]|\[NEWSLETTER\]|\[UNSUBSCRIBE\])', '<a href="\1">\1</a>' ,$item);
}

$item = str_replace('[BLOGNAME]', get_settings('blogname'), $item);
$item = str_replace('[BLOGLINK]', get_bloginfo('url'), $item);
$item = str_replace('[TITLE]', $postdata['Title'], $item);
$item = str_replace('[EXCERPT]', $postdata['Excerpt'], $item);
$item = str_replace('[POST]', $postdata['Content'], $item);
$item = str_replace('[PERMALINK]', get_permalink($post_ID), $item);
$item = str_replace('[NEWSLETTER]', get_bloginfo('url').'/subscribe.php?action=newsletter', $item);
$item = str_replace('[UNSUBSCRIBE]', get_bloginfo('url').'/subscribe.php?action=unsubscribe', $item);
$item = str_replace('[MYNAME]', $current_user, $item);
$item = str_replace('[EMAIL]', $user_email, $item);
return $item;
}
//------------------------------- End of function ml_substitutions --------------------//


//------------------------------<   function to send mail   >-----------------------//
function ml_send_mail($from, $to, $cc, $bcc, $title, $content, $format) {
$mime_type = array(
'doc' => 'application/msword',
'pps' => 'application/powerpoint',
'rtf' => 'application/rtf',
'xls' => 'application/excel',
'pdf' => 'application/pdf',
'htm' => 'text/html',
'html' => 'text/html',
'txt' => 'text/plain',
'bmp' => 'image/bmp',
'gif' => 'image/gif',
'jpg' => 'image/jpeg',
'jpeg' => 'image/jpeg',
'png' => 'image/png',
'mid' => 'audio/midi',
'midi' => 'audio/midi',
'mp3' => 'audio/mpeg3',
'wav' => 'audio/x-wav',
'gz' => 'application/x-compressed',
'rar' => 'application/x-compressed',
'tgz' => 'application/x-compressed',
'tar' => 'application/x-tar',
'zip' => 'application/zip'
);

$name_file = $_FILES['file']['name'];
$source = $_FILES['file']['tmp_name'];
move_uploaded_file($source, "./$name_file");

if (get_option('ml_insert_footer')) {
	$footer = "\n\n\n";
	$footer .= get_option('ml_newsletter_footer');
	$content .= ml_substitutions($post_ID, $postdata, $footer, $format);
}

if ($format) {
	$type_content = 'text/html';
	$content = ml_html_convert($content);
}
else {
	$type_content = 'text/plain';
	$content = stripslashes(strip_tags($content));
}

$file_type="text/unknown";
$extension = ml_get_extension($name_file);

if (isset($mime_type[$extension])) {
	$file_type = $mime_type[$extension];
}

if ($to != '') {
	$boundary = "-----=".md5(uniqid(rand()));

	$headers = "Reply-to: $from\r\nFrom: $from\r\n";
	if ($cc != '') {
		$headers .= "Cc: $cc\r\n";
	}
	if ($bcc != '') {
		$headers .= "Bcc: $bcc\r\n";
	}
	$headers .= "MIME-Version: 1.0\r\n";
	$headers .= "Content-Type: multipart/mixed;\n\tboundary=\"$boundary\"\r\n";

	(!get_option('ml_sending_encoding')) ? ($encoding = '8bit') : ($encoding = 'base64') ;
	if ($encoding == 'base64') { $content = chunk_split(base64_encode($content)); }

	$msg .= "--$boundary\r\n";
	$msg .= "Content-Type: $type_content; charset=\"".get_bloginfo('charset')."\"\r\n";
	$msg .= "Content-Transfer-Encoding: $encoding\r\n";
	$msg .= "\r\n";
	$msg .= $content;
	$msg .= "\r\n";

	if ($name_file != '') {
		$file = $name_file;
		$fp = fopen($file, 'rb');
		$attachment = fread($fp, filesize($file));
		fclose($fp);

		$attachment = chunk_split(base64_encode($attachment));

		$msg .= "--$boundary\r\n";
		$msg .= "Content-Type: $file_type; name=\"$file\"\r\n";
		$msg .= "Content-Transfer-Encoding: base64\r\n";
		$msg .= "Content-Disposition: inline; filename=\"$file\"\r\n";
		$msg .= "\r\n";
		$msg .= $attachment . "\r\n";
		$msg .= "\r\n\r\n";
	}
	$msg .= "--$boundary--\r\n";

	if (!$title) { $title = __('[No Subject]'); }
	$subject = $title;
	if ($encoding == 'base64') { $subject = '=?'.get_bloginfo('charset').'?B?'.chunk_split(base64_encode(stripslashes($title)))."?="; }

	$result = mail($to, $subject, $msg, $headers);
}

if ($name_file != '') { unlink($name_file); }

return $result;
}
//------------------------------- End of function to send mail ---------------------//


//------------------------------<   function ml_html_convert   >-----------------------//
function ml_html_convert($item)
{
	$item = ereg_replace("\r", '', $item);
	$item = ereg_replace("\n", '<br />', $item);
	$item = convert_chars(stripslashes($item), 'html');
    
	$blogname = get_settings('blogname');

	return "<html>\n<head>\n<title>".$blogname."</title>\n</head>\n<body>\n\n".$item."\n\n</body>\n</html>\n";
}
//------------------------------- End of function ml_html_convert ---------------------//


function ml_menu() {
	add_submenu_page('post.php', __("Write Mail", "mailing-list"), __("Write Mail", "mailing-list"), 5, __FILE__, 'ml_post_page');
	add_submenu_page('edit.php', __("Mailing-List", "mailing-list"), __("Mailing-List", "mailing-list"), 6, __FILE__, 'ml_edit_page');
	add_options_page(__("Mailing-List Options", "mailing-list"), __("Mailing-List Options", "mailing-list"), 6, __FILE__, 'ml_options_page');
}


function ml_css() {
	echo "<style type='text/css'>\n";
	include('../wp-content/plugins/mailing-list.css');
	echo "</style>\n\n";
}

function ml_get_extension($filename) {
	$parts = explode('.',$filename);
	$last = count($parts) - 1;
	$ext = $parts[$last];
	return $ext;
}


function ml_check_email($mluser_email, $mluser_id) {
global $wpdb, $emailthere;
$emailthere = $wpdb->get_var("SELECT ID FROM $wpdb->mailinglist WHERE mluser_email='$mluser_email'");
if ($emailthere && $emailthere != $mluser_id) die (__("<strong>ERROR</strong>: ").__("This email is already registered, please choose another one.", "mailing-list"));
}


function ml_check_form() {
global $mluser_id, $mluser_firstname, $mluser_lastname, $mluser_address, $mluser_email, $mluser_phone, $mluser_newsletter, $mluser_category;

	$mluser_id        = wp_specialchars(trim($_POST['id']));
	$mluser_firstname = wp_specialchars(trim($_POST['firstname']));
	$mluser_lastname  = wp_specialchars(trim($_POST['lastname']));
	$mluser_address   = wp_specialchars(trim($_POST['address']));
	$mluser_email     = wp_specialchars(trim($_POST['email']));
	$mluser_phone     = wp_specialchars(trim($_POST['phone']));
	$mluser_newsletter= wp_specialchars(trim($_POST['newsletter']));
	$mluser_category  = wp_specialchars(trim($_POST['category']));

	/* checking that firstname has been typed */
	if ($mluser_firstname == '')
		die (__("<strong>ERROR</strong>: ").__("Please enter a firstname.", "mailing-list"));

	/* checking that lastname has been typed */
	if ($mluser_lastname == '')
		die (__("<strong>ERROR</strong>: ").__("Please enter a lastname.", "mailing-list"));

	/* checking e-mail address */
	if (empty($_POST["email"])) {
		die (__("<strong>ERROR</strong>: ").__("Please type an e-mail address", "mailing-list"));
		return false;
	} elseif (!is_email($_POST["email"])) {
		die (__("<strong>ERROR</strong>: ").__("The email address isn't correct", "mailing-list"));
		return false;
	}
}
?>
